Index: /trunk/BNC/src/bnccore.cpp
===================================================================
--- /trunk/BNC/src/bnccore.cpp	(revision 6450)
+++ /trunk/BNC/src/bnccore.cpp	(revision 6451)
@@ -91,7 +91,7 @@
   _ephStreamSBAS    = 0;
 
-  _port    = 0;
-  _server  = 0;
-  _sockets = 0;
+  _portEph    = 0;
+  _serverEph  = 0;
+  _socketsEph = 0;
 
   _portCorr    = 0;
@@ -128,6 +128,6 @@
   delete _ephStreamGPS;
   delete _ephFileGPS;
-  delete _server;
-  delete _sockets;
+  delete _serverEph;
+  delete _socketsEph;
   delete _serverCorr;
   delete _socketsCorr;
@@ -437,11 +437,11 @@
   QString strV3 = eph.toString(t_rnxObsHeader::defaultRnxObsVersion3);
 
-  printOutput(printFile, _ephStreamGlonass, strV2, strV3);
+  printOutputEph(printFile, _ephStreamGlonass, strV2, strV3);
 }
 
 // Output
 ////////////////////////////////////////////////////////////////////////////
-void t_bncCore::printOutput(bool printFile, QTextStream* stream,
-                         const QString& strV2, const QString& strV3) {
+void t_bncCore::printOutputEph(bool printFile, QTextStream* stream,
+                               const QString& strV2, const QString& strV3) {
 
   // Output into file
@@ -459,6 +459,6 @@
   // Output into the socket
   // ----------------------
-  if (_sockets) {
-    QMutableListIterator<QTcpSocket*> is(*_sockets);
+  if (_socketsEph) {
+    QMutableListIterator<QTcpSocket*> is(*_socketsEph);
     while (is.hasNext()) {
       QTcpSocket* sock = is.next();
@@ -479,15 +479,15 @@
 // Set Port Number
 ////////////////////////////////////////////////////////////////////////////
-void t_bncCore::setPort(int port) {
-  _port = port;
-  if (_port != 0) {
-    delete _server;
-    _server = new QTcpServer;
-    if ( !_server->listen(QHostAddress::Any, _port) ) {
+void t_bncCore::setPortEph(int port) {
+  _portEph = port;
+  if (_portEph != 0) {
+    delete _serverEph;
+    _serverEph = new QTcpServer;
+    if ( !_serverEph->listen(QHostAddress::Any, _portEph) ) {
       slotMessage("t_bncCore: Cannot listen on ephemeris port", true);
     }
-    connect(_server, SIGNAL(newConnection()), this, SLOT(slotNewConnection()));
-    delete _sockets;
-    _sockets = new QList<QTcpSocket*>;
+    connect(_serverEph, SIGNAL(newConnection()), this, SLOT(slotNewConnectionEph()));
+    delete _socketsEph;
+    _socketsEph = new QList<QTcpSocket*>;
   }
 }
@@ -511,6 +511,6 @@
 // New Connection
 ////////////////////////////////////////////////////////////////////////////
-void t_bncCore::slotNewConnection() {
-  _sockets->push_back( _server->nextPendingConnection() );
+void t_bncCore::slotNewConnectionEph() {
+  _socketsEph->push_back( _serverEph->nextPendingConnection() );
 }
 
Index: /trunk/BNC/src/bnccore.h
===================================================================
--- /trunk/BNC/src/bnccore.h	(revision 6450)
+++ /trunk/BNC/src/bnccore.h	(revision 6451)
@@ -51,5 +51,5 @@
   void              setGUIenabled(bool GUIenabled) {_GUIenabled = GUIenabled;}
   void              setMode(e_mode mode) {_mode = mode;}
-  void              setPort(int port);
+  void              setPortEph(int port);
   void              setPortCorr(int port);
   void              setCaster(bncCaster* caster) {_caster = caster;}
@@ -101,5 +101,5 @@
     
  private slots:
-  void slotNewConnection();
+  void slotNewConnectionEph();
   void slotNewConnectionCorr();
 
@@ -107,6 +107,6 @@
   void printEphHeader();
   void printEph(const t_eph& eph, bool printFile);
-  void printOutput(bool printFile, QTextStream* stream, 
-                   const QString& strV2, const QString& strV3);
+  void printOutputEph(bool printFile, QTextStream* stream, 
+                      const QString& strV2, const QString& strV3);
   void messagePrivate(const QByteArray& msg);
 
@@ -130,7 +130,7 @@
   QString                _userName;
   QString                _pgmName;
-  int                    _port;
-  QTcpServer*            _server;
-  QList<QTcpSocket*>*    _sockets;
+  int                    _portEph;
+  QTcpServer*            _serverEph;
+  QList<QTcpSocket*>*    _socketsEph;
   int                    _portCorr;
   QTcpServer*            _serverCorr;
Index: /trunk/BNC/src/bncmain.cpp
===================================================================
--- /trunk/BNC/src/bncmain.cpp	(revision 6450)
+++ /trunk/BNC/src/bncmain.cpp	(revision 6451)
@@ -199,5 +199,5 @@
     
     BNC_CORE->setCaster(caster);
-    BNC_CORE->setPort(settings.value("outEphPort").toInt());
+    BNC_CORE->setPortEph(settings.value("outEphPort").toInt());
     BNC_CORE->setPortCorr(settings.value("corrPort").toInt());
     BNC_CORE->initCombination();
Index: /trunk/BNC/src/bncwindow.cpp
===================================================================
--- /trunk/BNC/src/bncwindow.cpp	(revision 6450)
+++ /trunk/BNC/src/bncwindow.cpp	(revision 6451)
@@ -1784,5 +1784,5 @@
 
   BNC_CORE->setCaster(_caster);
-  BNC_CORE->setPort(_outEphPortLineEdit->text().toInt());
+  BNC_CORE->setPortEph(_outEphPortLineEdit->text().toInt());
   BNC_CORE->setPortCorr(_corrPortLineEdit->text().toInt());
   BNC_CORE->initCombination();