Index: /trunk/BNC/src/PPP/pppClient.cpp
===================================================================
--- /trunk/BNC/src/PPP/pppClient.cpp	(revision 6462)
+++ /trunk/BNC/src/PPP/pppClient.cpp	(revision 6463)
@@ -116,7 +116,7 @@
 // 
 //////////////////////////////////////////////////////////////////////////////
-void t_pppClient::putBiases(const vector<t_satBias*>& biases) {
+void t_pppClient::putCodeBiases(const vector<t_satCodeBias*>& biases) {
   for (unsigned ii = 0; ii < biases.size(); ii++) {
-    _obsPool->putBias(new t_satBias(*biases[ii]));
+    _obsPool->putCodeBias(new t_satCodeBias(*biases[ii]));
   }
 }
Index: /trunk/BNC/src/PPP/pppClient.h
===================================================================
--- /trunk/BNC/src/PPP/pppClient.h	(revision 6462)
+++ /trunk/BNC/src/PPP/pppClient.h	(revision 6463)
@@ -28,5 +28,5 @@
   void putOrbCorrections(const std::vector<t_orbCorr*>& corr); 
   void putClkCorrections(const std::vector<t_clkCorr*>& corr); 
-  void putBiases(const std::vector<t_satBias*>& satBias);   
+  void putCodeBiases(const std::vector<t_satCodeBias*>& satBias);   
   void processEpoch(const std::vector<t_satObs*>& satObs, t_output* output);
 
Index: /trunk/BNC/src/PPP/pppObsPool.cpp
===================================================================
--- /trunk/BNC/src/PPP/pppObsPool.cpp	(revision 6462)
+++ /trunk/BNC/src/PPP/pppObsPool.cpp	(revision 6463)
@@ -42,5 +42,5 @@
 t_pppObsPool::t_pppObsPool() {
   for (unsigned ii = 0; ii <= t_prn::MAXPRN; ii++) {
-    _satBiases[ii] = 0;
+    _satCodeBiases[ii] = 0;
   }
 }
@@ -50,5 +50,5 @@
 t_pppObsPool::~t_pppObsPool() {
   for (unsigned ii = 0; ii <= t_prn::MAXPRN; ii++) {
-    delete _satBiases[ii];
+    delete _satCodeBiases[ii];
   }
   while (_epochs.size() > 0) {
@@ -60,8 +60,8 @@
 //
 /////////////////////////////////////////////////////////////////////////////
-void t_pppObsPool::putBias(t_satBias* satBias) {
-  int iPrn = satBias->_prn.toInt();
-  delete _satBiases[iPrn];
-  _satBiases[iPrn] = satBias;
+void t_pppObsPool::putCodeBias(t_satCodeBias* satCodeBias) {
+  int iPrn = satCodeBias->_prn.toInt();
+  delete _satCodeBiases[iPrn];
+  _satCodeBiases[iPrn] = satCodeBias;
 }
 
Index: /trunk/BNC/src/PPP/pppObsPool.h
===================================================================
--- /trunk/BNC/src/PPP/pppObsPool.h	(revision 6462)
+++ /trunk/BNC/src/PPP/pppObsPool.h	(revision 6463)
@@ -26,10 +26,10 @@
   t_pppObsPool();
   ~t_pppObsPool();
-  void putBias(t_satBias* satBias);
+  void putCodeBias(t_satCodeBias* satCodeBias);
 
   void putEpoch(const bncTime& epoTime, std::vector<t_pppSatObs*>& obsVector);
 
-  const t_satBias* satBias(const t_prn& prn) const {  
-    return _satBiases[prn.toInt()];
+  const t_satCodeBias* satCodeBias(const t_prn& prn) const {  
+    return _satCodeBiases[prn.toInt()];
   }
 
@@ -44,5 +44,5 @@
 
  private:
-  t_satBias*           _satBiases[t_prn::MAXPRN+1];
+  t_satCodeBias*       _satCodeBiases[t_prn::MAXPRN+1];
   std::deque<t_epoch*> _epochs;
 };
Index: /trunk/BNC/src/PPP/pppSatObs.cpp
===================================================================
--- /trunk/BNC/src/PPP/pppSatObs.cpp	(revision 6462)
+++ /trunk/BNC/src/PPP/pppSatObs.cpp	(revision 6463)
@@ -378,15 +378,14 @@
   _model._windUp = station->windUp(_time, _prn, rSat);
 
-  // Code and Phase Biases
-  // ---------------------
-  const t_satBias* satBias = PPP_CLIENT->obsPool()->satBias(_prn);
-  if (satBias) { 
-    for (unsigned ii = 0; ii < satBias->_bias.size(); ii++) {
-      const t_frqBias& bias = satBias->_bias[ii];
+  // Code Biases
+  // -----------
+  const t_satCodeBias* satCodeBias = PPP_CLIENT->obsPool()->satCodeBias(_prn);
+  if (satCodeBias) { 
+    for (unsigned ii = 0; ii < satCodeBias->_bias.size(); ii++) {
+      const t_frqCodeBias& bias = satCodeBias->_bias[ii];
       for (unsigned iFreq = 1; iFreq < t_frequency::max; iFreq++) {
         const t_frqObs* obs = _obs[iFreq];
         if (obs && obs->_rnxType2ch == bias._rnxType2ch) {
-          _model._codeBias[iFreq]  = bias._code;
-          _model._phaseBias[iFreq] = bias._phase;
+          _model._codeBias[iFreq]  = bias._value;
         }
       }
Index: /trunk/BNC/src/PPP_free/pppClient.h
===================================================================
--- /trunk/BNC/src/PPP_free/pppClient.h	(revision 6462)
+++ /trunk/BNC/src/PPP_free/pppClient.h	(revision 6463)
@@ -46,5 +46,5 @@
   void                putOrbCorrections(const std::vector<t_orbCorr*>& corr); 
   void                putClkCorrections(const std::vector<t_clkCorr*>& corr); 
-  void                putBiases(const std::vector<t_satBias*>& satBias);   
+  void                putBiases(const std::vector<t_satCodeBias*>& satCodeBias);   
   std::ostringstream& log() {return *_log;}
   const t_pppOptions* opt() const {return _opt;}
Index: /trunk/BNC/src/RTCM3/RTCM3coDecoder.cpp
===================================================================
--- /trunk/BNC/src/RTCM3/RTCM3coDecoder.cpp	(revision 6462)
+++ /trunk/BNC/src/RTCM3/RTCM3coDecoder.cpp	(revision 6463)
@@ -334,5 +334,5 @@
   // Code Biases
   // -----------
-  QList<t_satBias> satBiases;
+  QList<t_satCodeBias> satCodeBiases;
   for (unsigned ii = 0; ii < CLOCKORBIT_NUMGPS + _codeBias.NumberOfSat[CLOCKORBIT_SATGLONASS]; ii++) {
     char sysCh = ' ';
@@ -346,9 +346,7 @@
       continue;
     }
-    t_satBias satBias;
-    satBias._prn.set(sysCh, _codeBias.Sat[ii].ID);
-    satBias._time      = _lastTime;
-    satBias._nx        = 0;
-    satBias._jumpCount = 0;
+    t_satCodeBias satCodeBias;
+    satCodeBias._prn.set(sysCh, _codeBias.Sat[ii].ID);
+    satCodeBias._time      = _lastTime;
     for (unsigned jj = 0; jj < _codeBias.Sat[ii].NumberOfCodeBiases; jj++) {
     }
Index: /trunk/BNC/src/pppInclude.h
===================================================================
--- /trunk/BNC/src/pppInclude.h	(revision 6462)
+++ /trunk/BNC/src/pppInclude.h	(revision 6463)
@@ -116,5 +116,5 @@
   virtual void putOrbCorrections(const std::vector<t_orbCorr*>& corr) = 0; 
   virtual void putClkCorrections(const std::vector<t_clkCorr*>& corr) = 0; 
-  virtual void putBiases(const std::vector<t_satBias*>& satBias) = 0;
+  virtual void putBiases(const std::vector<t_satCodeBias*>& satCodeBias) = 0;
 };   
 
Index: /trunk/BNC/src/satObs.h
===================================================================
--- /trunk/BNC/src/satObs.h	(revision 6462)
+++ /trunk/BNC/src/satObs.h	(revision 6463)
@@ -93,27 +93,19 @@
 };
 
-class t_frqBias {
+class t_frqCodeBias {
  public:
-  t_frqBias() {
-    _code       = 0.0;          
-    _codeValid  = false;     
-    _phase      = 0.0;         
-    _phaseValid = false;    
+  t_frqCodeBias() {
+    _value = 0.0;          
   }
   std::string _rnxType2ch;
-  double      _code;          
-  bool        _codeValid;     
-  double      _phase;         
-  bool        _phaseValid;    
+  double      _value;
 };
 
-class t_satBias {
+class t_satCodeBias {
  public:
-  std::string            _staID;
-  t_prn                  _prn;
-  bncTime                _time;
-  int                    _nx;
-  int                    _jumpCount;
-  std::vector<t_frqBias> _bias;
+  std::string                _staID;
+  t_prn                      _prn;
+  bncTime                    _time;
+  std::vector<t_frqCodeBias> _bias;
 };
 