Index: /trunk/BNC/src/RTCM3/RTCM3coDecoder.h
===================================================================
--- /trunk/BNC/src/RTCM3/RTCM3coDecoder.h	(revision 6482)
+++ /trunk/BNC/src/RTCM3/RTCM3coDecoder.h	(revision 6483)
@@ -47,4 +47,6 @@
   void newClkCorrections(QList<t_clkCorr>);
   void newCodeBiases(QList<t_satCodeBias>);
+  void newPhaseBiases(QList<t_satPhaseBias>);
+  void newTec(t_vTec);
   void newMessage(QByteArray msg, bool showOnScreen);
   void providerIDChanged(QString staID);
@@ -58,20 +60,22 @@
   std::string codeTypeToRnxType(char system, CodeType type) const;
 
-  std::ofstream*                       _out;
-  QString                              _staID;
-  QString                              _fileNameSkl;
-  QString                              _fileName;
-  QByteArray                           _buffer;
-  ClockOrbit                           _clkOrb;
-  CodeBias                             _codeBias;
-  PhaseBias                            _phaseBias;
-  VTEC                                 _vTEC;
-  int                                  _providerID[3];
-  bncTime                              _lastTime;
-  QMap<t_prn, unsigned short>          _IODs;
-  QMap<bncTime, QList<t_orbCorr> >     _orbCorrections;
-  QMap<bncTime, QList<t_clkCorr> >     _clkCorrections;
-  QMap<t_prn, t_clkCorr>               _lastClkCorrections;
-  QMap<bncTime, QList<t_satCodeBias> > _codeBiases;
+  std::ofstream*                        _out;
+  QString                               _staID;
+  QString                               _fileNameSkl;
+  QString                               _fileName;
+  QByteArray                            _buffer;
+  ClockOrbit                            _clkOrb;
+  CodeBias                              _codeBias;
+  PhaseBias                             _phaseBias;
+  VTEC                                  _vTEC;
+  int                                   _providerID[3];
+  bncTime                               _lastTime;
+  QMap<t_prn, unsigned short>           _IODs;
+  QMap<bncTime, QList<t_orbCorr> >      _orbCorrections;
+  QMap<bncTime, QList<t_clkCorr> >      _clkCorrections;
+  QMap<t_prn, t_clkCorr>                _lastClkCorrections;
+  QMap<bncTime, QList<t_satCodeBias> >  _codeBiases;
+  QMap<bncTime, QList<t_satPhaseBias> > _phaseBiases;
+  QMap<bncTime, QList<t_vTec> >         _vTec;
 };
 
Index: /trunk/BNC/src/rinex/corrfile.cpp
===================================================================
--- /trunk/BNC/src/rinex/corrfile.cpp	(revision 6482)
+++ /trunk/BNC/src/rinex/corrfile.cpp	(revision 6483)
@@ -62,7 +62,9 @@
 void t_corrFile::syncRead(const bncTime& tt) {
 
-  _orbCorr.clear();
-  _clkCorr.clear();
-  _codeBiases.clear();
+  QList<t_clkCorr>      clkCorrList;
+  QList<t_orbCorr>      orbCorrList;
+  QList<t_satCodeBias>  satCodeBiasList;
+  QList<t_satPhaseBias> satPhaseBiasList;
+  t_vTec                vTec;
 
   while (!stopRead(tt) && _stream.good()) {
@@ -72,15 +74,18 @@
   }
 
-  if (_orbCorr.size() > 0) {
-    emit newOrbCorrections(_orbCorr);
-    _orbCorr.clear();
+  if (orbCorrList.size() > 0) {
+    emit newOrbCorrections(orbCorrList);
   }
-  if (_clkCorr.size() > 0) {
-    emit newClkCorrections(_clkCorr);
-    _clkCorr.clear();
+  if (clkCorrList.size() > 0) {
+    emit newClkCorrections(clkCorrList);
   }
-  if (_codeBiases.size() > 0) {
-    emit newCodeBiases(_codeBiases);
-    _codeBiases.clear();
+  if (satCodeBiasList.size() > 0) {
+    emit newCodeBiases(satCodeBiasList);
+  }
+  if (satPhaseBiasList.size() > 0) {
+    emit newPhaseBiases(satPhaseBiasList);
+  }
+  if (vTec._layers.size() > 0) {
+    emit newTec(vTec);
   }
 }
Index: /trunk/BNC/src/rinex/corrfile.h
===================================================================
--- /trunk/BNC/src/rinex/corrfile.h	(revision 6482)
+++ /trunk/BNC/src/rinex/corrfile.h	(revision 6483)
@@ -45,12 +45,11 @@
   void newClkCorrections(QList<t_clkCorr>);
   void newCodeBiases(QList<t_satCodeBias>);
+  void newPhaseBiases(QList<t_satPhaseBias>);
+  void newTec(t_vTec);
 
  private:
   bool stopRead(const bncTime& tt);
-  std::fstream         _stream;
-  QList<t_orbCorr>     _orbCorr;
-  QList<t_clkCorr>     _clkCorr;
-  QList<t_satCodeBias> _codeBiases;
-  QMap<QString, int>   _corrIODs;
+  std::fstream       _stream;
+  QMap<QString, int> _corrIODs;
 };
 