Index: /trunk/BNC/src/satObs.cpp
===================================================================
--- /trunk/BNC/src/satObs.cpp	(revision 6498)
+++ /trunk/BNC/src/satObs.cpp	(revision 6499)
@@ -43,5 +43,5 @@
 // 
 ////////////////////////////////////////////////////////////////////////////
-void t_clkCorr::readEpoch(const string epoLine, std::istream& in, QList<t_clkCorr>& corrList) {
+void t_clkCorr::readEpoch(const string& epoLine, std::istream& in, QList<t_clkCorr>& corrList) {
 }
 
@@ -84,5 +84,5 @@
 // 
 ////////////////////////////////////////////////////////////////////////////
-void t_orbCorr::readEpoch(const string epoLine, std::istream& in, QList<t_orbCorr>& corrList) {
+void t_orbCorr::readEpoch(const string& epoLine, std::istream& in, QList<t_orbCorr>& corrList) {
 }
 
@@ -116,5 +116,5 @@
 // 
 ////////////////////////////////////////////////////////////////////////////
-void t_satCodeBias::readEpoch(const string epoLine, std::istream& in, QList<t_satCodeBias>& biasList) {
+void t_satCodeBias::readEpoch(const string& epoLine, std::istream& in, QList<t_satCodeBias>& biasList) {
 }
 
@@ -153,5 +153,5 @@
 // 
 ////////////////////////////////////////////////////////////////////////////
-void t_satPhaseBias::readEpoch(const string epoLine, std::istream& in, QList<t_satPhaseBias>& biasList) {
+void t_satPhaseBias::readEpoch(const string& epoLine, std::istream& in, QList<t_satPhaseBias>& biasList) {
 }
 
@@ -180,10 +180,10 @@
 // 
 ////////////////////////////////////////////////////////////////////////////
-void t_vTec::read(const string epoLine, std::istream& in, t_vTec& vTec) {
+void t_vTec::read(const string& epoLine, std::istream& in, t_vTec& vTec) {
 }
 
 // 
 ////////////////////////////////////////////////////////////////////////////
-t_corrSSR::e_type t_corrSSR::readEpoLine(const string line, bncTime& epoTime) {
+t_corrSSR::e_type t_corrSSR::readEpoLine(const string& line, bncTime& epoTime) {
 
 }
Index: /trunk/BNC/src/satObs.h
===================================================================
--- /trunk/BNC/src/satObs.h	(revision 6498)
+++ /trunk/BNC/src/satObs.h	(revision 6499)
@@ -63,5 +63,5 @@
   t_orbCorr();
   static void writeEpoch(std::ostream* out, const QList<t_orbCorr>& corrList);
-  static void readEpoch(const std::string epoLine, std::istream& in, QList<t_orbCorr>& corrList);
+  static void readEpoch(const std::string& epoLine, std::istream& in, QList<t_orbCorr>& corrList);
   std::string    _staID;
   t_prn          _prn;
@@ -77,5 +77,5 @@
   t_clkCorr();
   static void writeEpoch(std::ostream* out, const QList<t_clkCorr>& corrList);
-  static void readEpoch(const std::string epoLine, std::istream& in, QList<t_clkCorr>& corrList);
+  static void readEpoch(const std::string& epoLine, std::istream& in, QList<t_clkCorr>& corrList);
   std::string    _staID;
   t_prn          _prn;
@@ -99,5 +99,5 @@
  public:
   static void writeEpoch(std::ostream* out, const QList<t_satCodeBias>& biasList);
-  static void readEpoch(const std::string epoLine, std::istream& in, QList<t_satCodeBias>& biasList);
+  static void readEpoch(const std::string& epoLine, std::istream& in, QList<t_satCodeBias>& biasList);
   std::string                _staID;
   t_prn                      _prn;
@@ -128,5 +128,5 @@
   }
   static void writeEpoch(std::ostream* out, const QList<t_satPhaseBias>& biasList);
-  static void readEpoch(const std::string epoLine, std::istream& in, QList<t_satPhaseBias>& biasList);
+  static void readEpoch(const std::string& epoLine, std::istream& in, QList<t_satPhaseBias>& biasList);
   std::string                 _staID;
   t_prn                       _prn;
@@ -147,5 +147,5 @@
  public:
   static void write(std::ostream* out, const t_vTec& vTec);
-  static void read(const std::string epoLine, std::istream& in, t_vTec& vTec);
+  static void read(const std::string& epoLine, std::istream& in, t_vTec& vTec);
   std::string              _staID;
   bncTime                  _time;
@@ -156,5 +156,5 @@
  public:
   enum e_type {clkCorr, orbCorr, codeBias, phaseBias, vTec, unknown};
-  static e_type readEpoLine(const std::string line, bncTime& epoTime);
+  static e_type readEpoLine(const std::string& line, bncTime& epoTime);
 };
 