Index: /trunk/BNC/src/satObs.cpp
===================================================================
--- /trunk/BNC/src/satObs.cpp	(revision 6506)
+++ /trunk/BNC/src/satObs.cpp	(revision 6507)
@@ -19,5 +19,5 @@
 // 
 ////////////////////////////////////////////////////////////////////////////
-void t_clkCorr::writeEpoch(std::ostream* out, const QList<t_clkCorr>& corrList) {
+void t_clkCorr::writeEpoch(ostream* out, const QList<t_clkCorr>& corrList) {
   if (!out || corrList.size() == 0) {
     return;
@@ -43,5 +43,5 @@
 // 
 ////////////////////////////////////////////////////////////////////////////
-void t_clkCorr::readEpoch(const string& epoLine, std::istream& in, QList<t_clkCorr>& corrList) {
+void t_clkCorr::readEpoch(const string& epoLine, istream& inStream, QList<t_clkCorr>& corrList) {
   bncTime epoTime;
   int     numCorr;
@@ -54,5 +54,5 @@
 
     string line;
-    getline(in, line);
+    getline(inStream, line);
     istringstream in(line.c_str());
     
@@ -74,5 +74,5 @@
 // 
 ////////////////////////////////////////////////////////////////////////////
-void t_orbCorr::writeEpoch(std::ostream* out, const QList<t_orbCorr>& corrList) {
+void t_orbCorr::writeEpoch(ostream* out, const QList<t_orbCorr>& corrList) {
   if (!out || corrList.size() == 0) {
     return;
@@ -101,5 +101,5 @@
 // 
 ////////////////////////////////////////////////////////////////////////////
-void t_orbCorr::readEpoch(const string& epoLine, std::istream& in, QList<t_orbCorr>& corrList) {
+void t_orbCorr::readEpoch(const string& epoLine, istream& inStream, QList<t_orbCorr>& corrList) {
   bncTime epoTime;
   int     numCorr;
@@ -112,5 +112,5 @@
 
     string line;
-    getline(in, line);
+    getline(inStream, line);
     istringstream in(line.c_str());
     
@@ -125,5 +125,5 @@
 // 
 ////////////////////////////////////////////////////////////////////////////
-void t_satCodeBias::writeEpoch(std::ostream* out, const QList<t_satCodeBias>& biasList) {
+void t_satCodeBias::writeEpoch(ostream* out, const QList<t_satCodeBias>& biasList) {
   if (!out || biasList.size() == 0) {
     return;
@@ -152,5 +152,5 @@
 // 
 ////////////////////////////////////////////////////////////////////////////
-void t_satCodeBias::readEpoch(const string& epoLine, std::istream& in, QList<t_satCodeBias>& biasList) {
+void t_satCodeBias::readEpoch(const string& epoLine, istream& inStream, QList<t_satCodeBias>& biasList) {
   bncTime epoTime;
   int     numSat;
@@ -163,5 +163,5 @@
 
     string line;
-    getline(in, line);
+    getline(inStream, line);
     istringstream in(line.c_str());
     
@@ -182,5 +182,5 @@
 // 
 ////////////////////////////////////////////////////////////////////////////
-void t_satPhaseBias::writeEpoch(std::ostream* out, const QList<t_satPhaseBias>& biasList) {
+void t_satPhaseBias::writeEpoch(ostream* out, const QList<t_satPhaseBias>& biasList) {
   if (!out || biasList.size() == 0) {
     return;
@@ -214,5 +214,5 @@
 // 
 ////////////////////////////////////////////////////////////////////////////
-void t_satPhaseBias::readEpoch(const string& epoLine, std::istream& in, QList<t_satPhaseBias>& biasList) {
+void t_satPhaseBias::readEpoch(const string& epoLine, istream& inStream, QList<t_satPhaseBias>& biasList) {
   bncTime epoTime;
   int     numSat;
@@ -225,5 +225,5 @@
 
     string line;
-    getline(in, line);
+    getline(inStream, line);
     istringstream in(line.c_str());
     
@@ -246,5 +246,5 @@
 // 
 ////////////////////////////////////////////////////////////////////////////
-void t_vTec::write(std::ostream* out, const t_vTec& vTec) {
+void t_vTec::write(ostream* out, const t_vTec& vTec) {
   if (!out || vTec._layers.size() == 0) {
     return;
@@ -268,5 +268,31 @@
 // 
 ////////////////////////////////////////////////////////////////////////////
-void t_vTec::read(const string& epoLine, std::istream& in, t_vTec& vTec) {
+void t_vTec::read(const string& epoLine, istream& inStream, t_vTec& vTec) {
+  bncTime epoTime;
+  int     numLayers;
+  string  staID;
+  if (t_corrSSR::readEpoLine(epoLine, epoTime, numLayers, staID) != t_corrSSR::vTec) {
+    return;
+  }
+  if (numLayers <= 0) {
+    return;
+  }
+  for (int ii = 0; ii < numLayers; ii++) {
+    t_vTecLayer layer;
+
+    string line;
+    getline(inStream, line);
+    istringstream in(line.c_str());
+
+    int dummy, maxDeg, maxOrd;
+    in >> dummy >> maxDeg >> maxOrd;
+
+    layer._C.ReSize(maxDeg, maxOrd);
+    layer._S.ReSize(maxDeg, maxOrd);
+
+    ////    inStream >> layer._C >> layer._S;
+
+    vTec._layers.push_back(layer);
+  }
 }
 