Index: /trunk/BNC/src/bncmap_svg.cpp
===================================================================
--- /trunk/BNC/src/bncmap_svg.cpp	(revision 6536)
+++ /trunk/BNC/src/bncmap_svg.cpp	(revision 6537)
@@ -141,5 +141,5 @@
   QwtText text(name.left(4));
   QFont   font = text.font();
-  font.setPointSize(font.pointSize()*0.8);
+  font.setPointSize(int(font.pointSize()*0.8));
   text.setFont(font);
   marker->setLabel(text);
Index: /trunk/BNC/src/bncutils.cpp
===================================================================
--- /trunk/BNC/src/bncutils.cpp	(revision 6536)
+++ /trunk/BNC/src/bncutils.cpp	(revision 6537)
@@ -589,5 +589,5 @@
 ////////////////////////////////////////////////////////////////////////////
 QString fortranFormat(double value, int width, int prec) {
-  int    expo = value == 0.0 ? 0 : log10(fabs(value));
+  int    expo = value == 0.0 ? 0 : int(log10(fabs(value)));
   double mant = value == 0.0 ? 0 : value / pow(10, expo);
   if (fabs(mant) >= 1.0) {
Index: /trunk/BNC/src/ephemeris.cpp
===================================================================
--- /trunk/BNC/src/ephemeris.cpp	(revision 6536)
+++ /trunk/BNC/src/ephemeris.cpp	(revision 6537)
@@ -1453,5 +1453,5 @@
 
   TOEw += 1356;  // BDT -> GPS week number
-  _TOE_bdt.set(TOEw, TOEs);
+  _TOE_bdt.set(int(TOEw), TOEs);
 
   // GPS->BDT
@@ -1648,5 +1648,5 @@
   out << QString(fmt)
     .arg(_TOE_bdt.gpssec(), 19, 'e', 12)
-    .arg(double(_AODC),     19, QChar(' '));
+    .arg(double(_AODC),     19, 'e', 12);
 
   return rnxStr;
Index: /trunk/BNC/src/pppRun.cpp
===================================================================
--- /trunk/BNC/src/pppRun.cpp	(revision 6536)
+++ /trunk/BNC/src/pppRun.cpp	(revision 6537)
@@ -375,5 +375,5 @@
     if (_speed < 100) {
       double sleepTime = 2.0 / _speed;
-      t_pppThread::msleep(sleepTime*1.e3);
+      t_pppThread::msleep(int(sleepTime*1.e3));
     }
 
Index: /trunk/BNC/src/rinex/availplot.cpp
===================================================================
--- /trunk/BNC/src/rinex/availplot.cpp	(revision 6536)
+++ /trunk/BNC/src/rinex/availplot.cpp	(revision 6537)
@@ -63,5 +63,5 @@
  public:
   t_scaleDrawPrn() {}
-  virtual QwtText label(double iPrn) const {
+  virtual QwtText label(int iPrn) const {
     return _yLabels[iPrn];
   }
Index: /trunk/BNC/src/rinex/dopplot.cpp
===================================================================
--- /trunk/BNC/src/rinex/dopplot.cpp	(revision 6536)
+++ /trunk/BNC/src/rinex/dopplot.cpp	(revision 6537)
@@ -77,5 +77,5 @@
   QwtText textPDOP("PDOP");
   QFont   fontPDOP = textPDOP.font();
-  fontPDOP.setPointSize(fontPDOP.pointSize()*0.8);
+  fontPDOP.setPointSize(int(fontPDOP.pointSize()*0.8));
   textPDOP.setFont(fontPDOP);
   textPDOP.setColor(Qt::red);
@@ -85,5 +85,5 @@
   QwtText textNumSat("# Sat");
   QFont   fontNumSat = textNumSat.font();
-  fontNumSat.setPointSize(fontNumSat.pointSize()*0.8);
+  fontNumSat.setPointSize(int(fontNumSat.pointSize()*0.8));
   textNumSat.setFont(fontNumSat);
   textNumSat.setColor(Qt::blue);
Index: /trunk/BNC/src/rinex/eleplot.cpp
===================================================================
--- /trunk/BNC/src/rinex/eleplot.cpp	(revision 6536)
+++ /trunk/BNC/src/rinex/eleplot.cpp	(revision 6537)
@@ -96,5 +96,5 @@
         const QVector<double>& xData = plotData._mjdX24;
         const QVector<double>& yData = plotData._eleDeg;
-        QColor color = QColor::fromHsv((iC-1)*(359.0/numCurves), 255, 255);
+        QColor color = QColor::fromHsv(int((iC-1)*(359.0/numCurves)), 255, 255);
         QwtSymbol symbol(QwtSymbol::Rect, QBrush(color), QPen(color), QSize(1,1));
         addCurve(prn, symbol, xData, yData);
Index: /trunk/BNC/src/rinex/reqcedit.cpp
===================================================================
--- /trunk/BNC/src/rinex/reqcedit.cpp	(revision 6536)
+++ /trunk/BNC/src/rinex/reqcedit.cpp	(revision 6537)
@@ -254,5 +254,5 @@
     }
     if (ii == 0) {
-      outObsFile.setHeader(obsFile->header(), _rnxVersion, &useObsTypes);
+      outObsFile.setHeader(obsFile->header(), int(_rnxVersion), &useObsTypes);
       if (_begTime.valid() && _begTime > outObsFile.startTime()) {
         outObsFile.setStartTime(_begTime);